LinkedList

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class LinkedList

    java.lang.Object
      java.util.AbstractCollection
          java.util.AbstractList
              java.util.AbstractSequentialList
                  java.util.LinkedList

All Implemented Interfaces:
  Serializable, Cloneable, Collection, List

    public class LinkedList

extends AbstractSequentialList
implements List, Cloneable, Serializable

Linked list implementation of the `List` interface. Implements all optional list operations, and permits all elements (including `null`). In addition to implementing the `List` interface, the `LinkedList` class provides uniformly named methods to `get`, `remove` and `insert` an element at the beginning and end of the list. These operations allow linked lists to be used as a stack, queue, or double-ended queue (deque).

All of the stack/queue/deque operations could be easily recast in terms of the standard list operations. They're included here primarily for convenience, though they may run slightly faster than the equivalent List operations.

All of the operations perform as could be expected for a doubly-linked list. Operations that index into the list will traverse the list from the begining or the end, whichever is closer to the specified index.

Note that this implementation is not synchronized. If multiple threads access a list concurrently, and at least one of the threads modifies the list structurally, it must be synchronized externally. (A structural modification is any operation that adds or deletes one or more elements; merely setting the value of an element is not a structural modification.) This is typically accomplished by synchronizing on some object that naturally encapsulates the list. If no such object exists, the list should be "wrapped" using the Collections.synchronizedList method. This is best done at creation time, to prevent accidental unsynchronized access to the list:

         List list = Collections.synchronizedList(new LinkedList(...));

The iterators returned by the this class's `iterator` and `listIterator` methods are fail-fast: if the list is structurally modified at any time after the iterator is created, in any way except through the Iterator's own `remove` or `add` methods, the iterator will throw a `ConcurrentModificationException`. Thus, in the face of concurrent modification, the iterator fails quickly and cleanly, rather than risking arbitrary, non-deterministic behavior at an undetermined time in the future.

Note that the fail-fast behavior of an iterator cannot be guaranteed as it is, generally speaking, impossible to make any hard guarantees in the presence of unsynchronized concurrent modification. Fail-fast iterators throw `ConcurrentModificationException` on a best-effort basis. Therefore, it would be wrong to write a program that depended on this exception for its correctness: the fail-fast behavior of iterators should be used only to detect bugs.

This class is a member of the Java Collections Framework.

Since:
  1.2
Version:
  1.37, 03/12/05
Author:
  Josh Bloch
See Also:
  `List`, `ArrayList`, `Vector`, `Collections.synchronizedList(List)`, Serialized Form

Constructor Summary
`LinkedList()` Constructs an empty list.
`LinkedList(Collection c)` Constructs a list containing the elements of the specified collection, in the order they are returned by the collection's iterator.

Method Summary
`void` | `add(int index, Object element)` Inserts the specified element at the specified position in this list.
`boolean` | `add(Object o)` Appends the specified element to the end of this list.
`boolean` | `addAll(Collection c)` Appends all of the elements in the specified collection to the end of this list, in the order that they are returned by the specified collection's iterator.
`boolean` | `addAll(int index, Collection c)` Inserts all of the elements in the specified collection into this list, starting at the specified position.
`void` | `addFirst(Object o)` Inserts the given element at the beginning of this list.
`void` | `addLast(Object o)` Appends the given element to the end of this list.
`void` | `clear()` Removes all of the elements from this list.
`Object` | `clone()` Returns a shallow copy of this `LinkedList`.
`boolean` | `contains(Object o)` Returns `true` if this list contains the specified element.
`Object` | `get(int index)` Returns the element at the specified position in this list.
`Object` | `getFirst()` Returns the first element in this list.
`Object` | `getLast()` Returns the last element in this list.
`int` | `indexOf(Object o)` Returns the index in this list of the first occurrence of the specified element, or -1 if the List does not contain this element.
`int` | `lastIndexOf(Object o)` Returns the index in this list of the last occurrence of the specified element, or -1 if the list does not contain this element.
`ListIterator` | `listIterator(int index)` Returns a list-iterator of the elements in this list (in proper sequence), starting at the specified position in the list.
`Object` | `remove(int index)` Removes the element at the specified position in this list.
`boolean` | `remove(Object o)` Removes the first occurrence of the specified element in this list.
`Object` | `removeFirst()` Removes and returns the first element from this list.
`Object` | `removeLast()` Removes and returns the last element from this list.
`Object` | `set(int index, Object element)` Replaces the element at the specified position in this list with the specified element.
`int` | `size()` Returns the number of elements in this list.
`Object[]` | `toArray()` Returns an array containing all of the elements in this list in the correct order.
`Object[]` | `toArray(Object[] a)` Returns an array containing all of the elements in this list in the correct order; the runtime type of the returned array is that of the specified array.

Methods inherited from class java.util.AbstractSequentialList
`iterator`

Methods inherited from class java.util.AbstractList
`equals, hashCode, listIterator, subList`

Methods inherited from class java.util.AbstractCollection
`containsAll, isEmpty, removeAll, retainAll, toString`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.List
`containsAll, equals, hashCode, isEmpty, iterator, listIterator, removeAll, retainAll, subList`

Constructor Detail

### LinkedList

    public LinkedList()

  Constructs an empty list.

### LinkedList

    public LinkedList(Collection c)

  Constructs a list containing the elements of the specified collection, in the order they are returned by the collection's iterator.

  Parameters:
    `c` - the collection whose elements are to be placed into this list.
  Throws:
    `NullPointerException` - if the specified collection is null.

Method Detail

### getFirst

    public Object getFirst()

  Returns the first element in this list.

  Returns:
    the first element in this list.
  Throws:
    `NoSuchElementException` - if this list is empty.

### getLast

    public Object getLast()

  Returns the last element in this list.

  Returns:
    the last element in this list.
  Throws:
    `NoSuchElementException` - if this list is empty.

### removeFirst

    public Object removeFirst()

  Removes and returns the first element from this list.

  Returns:
    the first element from this list.
  Throws:
    `NoSuchElementException` - if this list is empty.

### removeLast

    public Object removeLast()

  Removes and returns the last element from this list.

  Returns:
    the last element from this list.
  Throws:
    `NoSuchElementException` - if this list is empty.

### addFirst

    public void addFirst(Object o)

  Inserts the given element at the beginning of this list.

  Parameters:
    `o` - the element to be inserted at the beginning of this list.

### addLast

    public void addLast(Object o)

  Appends the given element to the end of this list. (Identical in function to the `add` method; included only for consistency.)

  Parameters:
    `o` - the element to be inserted at the end of this list.

### contains

    public boolean contains(Object o)

  Returns `true` if this list contains the specified element. More formally, returns `true` if and only if this list contains at least one element `e` such that `(o==null ? e==null : o.equals(e))`.

  Specified by:
    `contains` in interface `Collection`
  Specified by:
    `contains` in interface `List`
  Overrides:
    `contains` in class `AbstractCollection`
  Parameters:
    `o` - element whose presence in this list is to be tested.
  Returns:
    `true` if this list contains the specified element.

### size

    public int size()

  Returns the number of elements in this list.

  Specified by:
    `size` in interface `Collection`
  Specified by:
    `size` in interface `List`
  Specified by:
    `size` in class `AbstractCollection`
  Returns:
    the number of elements in this list.

### add

    public boolean add(Object o)

  Appends the specified element to the end of this list.

  Specified by:
    `add` in interface `Collection`
  Specified by:
    `add` in interface `List`
  Overrides:
    `add` in class `AbstractList`
  Parameters:
    `o` - element to be appended to this list.
  Returns:
    `true` (as per the general contract of `Collection.add`).

### remove

    public boolean remove(Object o)

  Removes the first occurrence of the specified element in this list. If the list does not contain the element, it is unchanged. More formally, removes the element with the lowest index `i` such that `(o==null ? get(i)==null : o.equals(get(i)))` (if such an element exists).

  Specified by:
    `remove` in interface `Collection`
  Specified by:
    `remove` in interface `List`
  Overrides:
    `remove` in class `AbstractCollection`
  Parameters:
    `o` - element to be removed from this list, if present.
  Returns:
    `true` if the list contained the specified element.

### addAll

    public boolean addAll(Collection c)

  Appends all of the elements in the specified collection to the end of this list, in the order that they are returned by the specified collection's iterator. The behavior of this operation is undefined if the specified collection is modified while the operation is in progress. (This implies that the behavior of this call is undefined if the specified Collection is this list, and this list is nonempty.)

  Specified by:
    `addAll` in interface `Collection`
  Specified by:
    `addAll` in interface `List`
  Overrides:
    `addAll` in class `AbstractCollection`
  Parameters:
    `c` - the elements to be inserted into this list.
  Returns:
    `true` if this list changed as a result of the call.
  Throws:
    `NullPointerException` - if the specified collection is null.
  See Also:
    `AbstractCollection.add(Object)`

### addAll

    public boolean addAll(int index,
                          Collection c)

  Inserts all of the elements in the specified collection into this list, starting at the specified position. Shifts the element currently at that position (if any) and any subsequent elements to the right (increases their indices). The new elements will appear in the list in the order that they are returned by the specified collection's iterator.

  Specified by:
    `addAll` in interface `List`
  Overrides:
    `addAll` in class `AbstractSequentialList`
  Parameters:
    `index` - index at which to insert first element from the specified collection.
    `c` - elements to be inserted into this list.
  Returns:
    `true` if this list changed as a result of the call.
  Throws:
    `IndexOutOfBoundsException` - if the specified index is out of range (`index < 0 || index > size()`).
    `NullPointerException` - if the specified collection is null.

### clear

    public void clear()

  Removes all of the elements from this list.

  Specified by:
    `clear` in interface `Collection`
  Specified by:
    `clear` in interface `List`
  Overrides:
    `clear` in class `AbstractList`

### get

    public Object get(int index)

  Returns the element at the specified position in this list.

  Specified by:
    `get` in interface `List`
  Overrides:
    `get` in class `AbstractSequentialList`
  Parameters:
    `index` - index of element to return.
  Returns:
    the element at the specified position in this list.
  Throws:
    `IndexOutOfBoundsException` - if the specified index is is out of range (`index < 0 || index >= size()`).

### set

    public Object set(int index,
                      Object element)

  Replaces the element at the specified position in this list with the specified element.

  Specified by:
    `set` in interface `List`
  Overrides:
    `set` in class `AbstractSequentialList`
  Parameters:
    `index` - index of element to replace.
    `element` - element to be stored at the specified position.
  Returns:
    the element previously at the specified position.
  Throws:
    `IndexOutOfBoundsException` - if the specified index is out of range (`index < 0 || index >= size()`).

### add

    public void add(int index,
                    Object element)

  Inserts the specified element at the specified position in this list. Shifts the element currently at that position (if any) and any subsequent elements to the right (adds one to their indices).

  Specified by:
    `add` in interface `List`
  Overrides:
    `add` in class `AbstractSequentialList`
  Parameters:
    `index` - index at which the specified element is to be inserted.
    `element` - element to be inserted.
  Throws:
    `IndexOutOfBoundsException` - if the specified index is out of range (`index < 0 || index > size()`).

### remove

    public Object remove(int index)

  Removes the element at the specified position in this list. Shifts any subsequent elements to the left (subtracts one from their indices). Returns the element that was removed from the list.

  Specified by:
    `remove` in interface `List`
  Overrides:
    `remove` in class `AbstractSequentialList`
  Parameters:
    `index` - the index of the element to removed.
  Returns:
    the element previously at the specified position.
  Throws:
    `IndexOutOfBoundsException` - if the specified index is out of range (`index < 0 || index >= size()`).

### indexOf

    public int indexOf(Object o)

  Returns the index in this list of the first occurrence of the specified element, or -1 if the List does not contain this element. More formally, returns the lowest index i such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.

  Specified by:
    `indexOf` in interface `List`
  Overrides:
    `indexOf` in class `AbstractList`
  Parameters:
    `o` - element to search for.
  Returns:
    the index in this list of the first occurrence of the specified element, or -1 if the list does not contain this element.

### lastIndexOf

    public int lastIndexOf(Object o)

  Returns the index in this list of the last occurrence of the specified element, or -1 if the list does not contain this element. More formally, returns the highest index i such that `(o==null ? get(i)==null : o.equals(get(i)))`, or -1 if there is no such index.

  Specified by:
    `lastIndexOf` in interface `List`
  Overrides:
    `lastIndexOf` in class `AbstractList`
  Parameters:
    `o` - element to search for.
  Returns:
    the index in this list of the last occurrence of the specified element, or -1 if the list does not contain this element.

### listIterator

    public ListIterator listIterator(int index)

  Returns a list-iterator of the elements in this list (in proper sequence), starting at the specified position in the list. Obeys the general contract of `List.listIterator(int)`.

  The list-iterator is fail-fast: if the list is structurally modified at any time after the Iterator is created, in any way except through the list-iterator's own `remove` or `add` methods, the list-iterator will throw a `ConcurrentModificationException`. Thus, in the face of concurrent modification, the iterator fails quickly and cleanly, rather than risking arbitrary, non-deterministic behavior at an undetermined time in the future.

  Specified by:
    `listIterator` in interface `List`
  Specified by:
    `listIterator` in class `AbstractSequentialList`
  Parameters:
    `index` - index of first element to be returned from the list-iterator (by a call to `next`).
  Returns:
    a ListIterator of the elements in this list (in proper sequence), starting at the specified position in the list.
  Throws:
    `IndexOutOfBoundsException` - if index is out of range (`index < 0 || index > size()`).
  See Also:
    `List.listIterator(int)`

### clone

    public Object clone()

  Returns a shallow copy of this `LinkedList`. (The elements themselves are not cloned.)

  Returns:
    a shallow copy of this `LinkedList` instance.
  See Also:
    `Cloneable`

### toArray

    public Object[] toArray()

  Returns an array containing all of the elements in this list in the correct order.

  Specified by:
    `toArray` in interface `Collection`
  Specified by:
    `toArray` in interface `List`
  Overrides:
    `toArray` in class `AbstractCollection`
  Returns:
    an array containing all of the elements in this list in the correct order.
  See Also:
    `Arrays.asList(Object[])`

### toArray

    public Object[] toArray(Object[] a)

  Returns an array containing all of the elements in this list in the correct order; the runtime type of the returned array is that of the specified array. If the list fits in the specified array, it is returned therein. Otherwise, a new array is allocated with the runtime type of the specified array and the size of this list.

  If the list fits in the specified array with room to spare (i.e., the array has more elements than the list), the element in the array immediately following the end of the collection is set to null. This is useful in determining the length of the list only if the caller knows that the list does not contain any null elements.

  Specified by:
    `toArray` in interface `Collection`
  Specified by:
    `toArray` in interface `List`
  Overrides:
    `toArray` in class `AbstractCollection`
  Parameters:
    `a` - the array into which the elements of the list are to be stored, if it is big enough; otherwise, a new array of the same runtime type is allocated for this purpose.
  Returns:
    an array containing the elements of the list.
  Throws:
    `ArrayStoreException` - if the runtime type of a is not a supertype of the runtime type of every element in this list.
    `NullPointerException` - if the specified array is null.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD